; -------------------------------------------------------------------------------
; LCD GRAFICO BASICO                     
; 
; Este programa apenas desenha um retangulo na coluna 40 da pagina 3 do LCD.
;
; -------------------------------------------------------------------------------
        list        p=18f4620
        #include    <p18f4620.inc>
        errorlevel  -302

        CONFIG WDT   = OFF       ; configuration bits
        CONFIG MCLRE = ON        ; configuration bits
        CONFIG DEBUG = OFF       ; configuration bits
        CONFIG LVP   = OFF       ; configuration bits
        CONFIG OSC   = HS        ; configuration bits

        UDATA   0x80
#define GLCD_DATATRIS TRISB	     ; controle de I/O da porta de dados/comandos
#define GLCD_DATAIN   PORTB      ; porta de dados/comandos
#define GLCD_DATAOUT  LATB       ; alias da porta de dados/comandos

#define GLCD_CNT      PORTC      ; porta de controle para o LCD
#define GLCD_CNTRIS   TRISC      ; controle de I/O da porta de controle
#define GLCD_CNTDI    0          ; ao pino DI  do LCD........ dado/ou instrucao  
#define GLCD_CNTRW    1          ; ao pino RW  do LCD........ read/write 
#define GLCD_CNTE     2          ; ao pino EN  do LCD........ chip enable 
#define GLCD_CNTCS1   3          ; ao pino CS1 do LCD........ lado 1  
#define GLCD_CNTCS2   4          ; ao pino CS2 do LCD........ lado 2  
#define GLCD_CNTRST   5          ; ao pino RST do LCD........ restart

GLCD_W1         RES     1        ; registrador de trabalho  
GLCD_W2         RES     1        ; registrador de trabalho  
GLCD_Delay1     RES     1        ; registrador de trabalho
GLCD_RC1        RES     1        ; registrador de controle 
GLCD_PAGE       RES     1        ; numero da pagina
GLCD_COL        RES     1        ; numero da coluna

; ----------------------------------------------------------------------------------------------------------
rst_code     CODE   0x000
             goto   inicio
hi_prty_int  CODE   0x008
             retfie
; ----------------------------------------------------------------------------------------------------------
MAIN        CODE  

             #include "ks0108.inc"               ; Funcoes para o LCD grafico

; ----------------------------------------------------------------------------------------------------------
inicio      movlw    0x0F                        ; mascara para digital ports
            movwf    ADCON1                      ; configura todos os pinos como digital
            clrf     LATD                        ; limpa PORTD
            clrf     LATC                        ; limpa PORTC
            clrf     TRISD                       ; PORTD tudo saida
            clrf     TRISC                       ; PORTC tudo saida
            call     GLCD_Init                   ; inicializa o LCD
            call     GLCD_Enable1                ; habilita lado 1
            call     GLCD_Enable2                ; habilita lado 2
            call     GLCD_Clear                  ; apaga a tela do LCD
            call     GLCD_Enable1                ; habilita o lado 1
            movlw    START_LINE                  ; comando para posicionar linha zero
            call     GLCD_Command                ; envia o comando ao LCD
            movlw    .3                          ; numero da pagina 
            iorlw    X_ADDRESS                   ; insere pagina no comando
            call     GLCD_Command                ; envia o comando
            movlw    .40                         ; numero da coluna
            iorlw    Y_ADDRESS                   ; insere coluna no comando
            call     GLCD_Command                ; envia o comando
            call     retangulo                   ; desenha o retangulo
parada      goto     parada                      ; fica parado aqui


            ;
            ; Desenha um retangulo
            ;
retangulo   movlw    0xFF
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0x81
            call     GLCD_Write
            movlw    0xFF
            call     GLCD_Write
            return
     
            END